﻿-------------------------------------------------------------------------------------
-- Derby Lua Script
-- By Bidwars
-------------------------------------------------------------------------------------

local M = {}
math.randomseed(os.time())  --This is used for Random Math.
local helper = require('scenario/scenariohelper')
local scenarioVehicles = derby_main.scenarioVehicles  --List of vehicles
local vdata = {}  -- Current ai vehicle data
local tdata = {}  --Target data
require('mathlib')
-------------------------------------------------------------------------------------
--RETURNS A TARGET FOR THE AI  *vNotToTarget - set AI to not target itself
-------------------------------------------------------------------------------------
local function findRandomTarget(vNotToTarget)
	local target = {}
	for vName, vObj in pairs(scenarioVehicles) do
		if vName ~= vNotToTarget and not derby_main.vTimeout[vName] then
			if derby_main.vehIn > 2 then
				if derby_main.vehiclesStopTicks[vName] < 30 then
					if vName ~=	derby_util.vehicleData[vNotToTarget].targetOut then table.insert(target, vName) end
				end
			else 
				table.insert(target, vName)
			end
		end
	end	
	math.random(); math.random(); math.random()
	local j = math.random(1, #target)
	return target[j]
end
-------------------------------------------------------------------------------------
--OBJECT TO AVOID BEHIND OR AHEAD 
-------------------------------------------------------------------------------------
local function aiflee(t)
	local tpos = nil
		tpos = t 
		local dirDiff, dirTarget, dirVec = derby_util.vec2Diff(tpos, vdata)
		return dirDiff, dirTarget
end
-------------------------------------------------------------------------------------
--GETS DIRECTION AND DISTANCE OF THE TARGET
-------------------------------------------------------------------------------------
local function aiPursuit(dt,d,speed)
		local distance = d
		local tpos = tdata.pos
		local dirDiff, dirTarget, dirVec = derby_util.vec2Diff(tpos, vdata)
		--local aiVel2Target = vec3(vdata.vel):dot((tpos - vdata.pos):normalized())
		--local aiTimeToTarget =  distance / speed  --(tdata.pos - vdata.pos):length() / (aiVel2Target + 1e-30)
		local futurePos = tpos + (tdata.vel * dt)--aiTimeToTarget)
		local targetVec = (futurePos - vdata.pos):normalized()
		--debugDrawer:drawSphere(targetVec:toPoint3F(), 4, ColorF(1,0,0,0.3))
		dirTarget = dirVec:dot(targetVec)
		--debugDrawer:drawLine(vdata.pos:toPoint3F(), futurePos:toPoint3F(), ColorF(1,0,0,0.5))
		local dirDiff2 = math.asin(dirVec.x * targetVec.y - dirVec.y * targetVec.x)
		if dirDiff2 > 0 or dirDiff2 < 0 then
			dirDiff = dirDiff2
		end
		return dirDiff, dirTarget
end
-------------------------------------------------------------------------------------
--RESET TARGET 
-------------------------------------------------------------------------------------
local function reset(data)
	data.targetSet = false
	data.target = nil
	data.targetObj = {}
end

-------------------------------------------------------------------------------------
--TURN WHEEL AT DIFFERENT DISTANCES
-------------------------------------------------------------------------------------
local function distanceAction(distance1, dirDiff)
	print(dirDiff)
	if dirDiff > 0 then
		if distance1 < 10 then
			dirDiff = 1.00
		elseif distance1 < 7 then
			dirDiff = 1.33
		elseif distance1 < 4 then
			dirDiff = 1.55
		end
	else 
			if distance1 < 10 then
			dirDiff = -1.00
		elseif distance1 < 7 then
			dirDiff = -1.33
		elseif distance1 < 4 then
			dirDiff = -1.55
		end
	end
	return dirDiff
end
-------------------------------------------------------------------------------------
--CHECK IF WE ARE GONG TO HIT WALLS
-------------------------------------------------------------------------------------
local function wall(wp1,wp2,speed)
	--local aheadDis = speed + 2
	local ahead = vdata.pos + (vdata.vel):normalized() * speed
	local result = nil
	local dx = nil
	local dy = nil
	dx, dy, result = derby_util.findIntersect(vdata.pos.x, vdata.pos.y, ahead.x,ahead.y, wp1.x, wp1.y, wp1.x, wp2.y)
	if result == nil then
		dx, dy, result = derby_util.findIntersect(vdata.pos.x, vdata.pos.y, ahead.x,ahead.y, wp2.x, wp2.y, wp2.x, wp1.y)
	end
	if result == nil then 
		dx, dy, result = derby_util.findIntersect(vdata.pos.x, vdata.pos.y, ahead.x,ahead.y, wp1.x, wp1.y, wp2.x, wp1.y)
	end
	if result == nil then
		dx, dy, result = derby_util.findIntersect(vdata.pos.x, vdata.pos.y, ahead.x,ahead.y, wp2.x, wp2.y, wp1.x, wp2.y)
	end
	local dz = vdata.pos.z
	local lineIntersect = vec3(dx, dy, dz)
	return lineIntersect, result
end
-------------------------------------------------------------------------------------
--CHECKS FOR COLLISIONS WITH OBJECTS 
-------------------------------------------------------------------------------------
local function collisionCheck(dt,wp1,wp2,data,Arena)
	local dirDiff
	local dirTarget 
	data.tDist = vec3(vdata.pos):distance(vec3(tdata.pos))
	local speed = vdata.vel:length()
	dirDiff, dirTarget = aiPursuit(dt,data.tDist, speed)
	if Arena == 1 then
			local cr = 6 
			local cx = 157.99
			local cy = -198.1715
			local z = 58.55
			local circle = vec3(cx,cy,z)	 
			--debugDrawer:drawSphere(circle:toPoint3F(), cr, ColorF(1,0,0,0.3))
			local ahead2 = vdata.pos + (vdata.vel):normalized() * 3
			local ahead3 = vdata.pos + (vdata.vel):normalized() * 3 * 0.5
			local distance1 = vec3(ahead2):distance(vec3(circle))
			local distance2 = vec3(ahead3):distance(vec3(circle))
			cr = cr + 3
			if distance1 <= cr or distance2 <= cr then
				dirDiff	= distanceAction(distance1, dirDiff)
				data.avoid = true
			return dirDiff, dirTarget
			end
	end	
	local lineIntersect, result = wall(wp1, wp2, speed)
	if result ~= nil or data.collision == true then	
		--debugDrawer:drawLine(vdata.pos:toPoint3F(), data.lineDist:toPoint3F(), ColorF(1,0,0,0.5))
			dirDiff, dirTarget = aiflee(data.startPos)
			data.sDist = vec3(vdata.pos):distance(vec3(data.startPos))
			--dirDiff = 0 
			if dirTarget < 0 then
				if speed > 6 then
					data.brake = .6
				end
					data.backup = true
			else 
				if speed > 6 then
					data.throttle = .7
				end
					data.backup = false
			end
			data.collision = true
	end
	return dirDiff, dirTarget
end
-------------------------------------------------------------------------------------
--CHANGES THE DIRECTION FOR FORWARE TO BACKWARDS
-------------------------------------------------------------------------------------
local function changeDir(data)
	if data.backup == false then
		data.backup = true
	else 
		data.backup = false
	end
end
-------------------------------------------------------------------------------------
--SETS THE COUNT FOR HOW LONG WE GO FORWARD OR BACKWARDS
-------------------------------------------------------------------------------------
local function counts(data,vName)
	if data.collision == false or data.avoid == true then					
		if data.lasthit == true then
		
			if data.lCount == 1 then 
				changeDir(data)
			end
			if data.lCount > 150 or data.tDist > 12 then
				if data.hitTarget == true then
					reset(data)
					data.hitTarget = false
				end
				data.lasthit = false
				data.lCount = 0
			else
				data.lCount = data.lCount + 1
			end
		else
			if data.dtCount > 300 then 
				changeDir(data)
				data.dtCount = 0
				data.lCount = 0
				reset(data)
			end
			data.dtCount = data.dtCount + 1
		end
	else
		if data.avoid == true then
			if data.cCount > 150 then 
				data.cCount = 0
				data.avoid = false
			else 
				data.cCount = data.cCount + 1
			end
		else
			if data.sDist < 10 or data.cCount > 150 then
				if derby_main.vehiclesStopTicks[vName] > 30 then
					changeDir(data)
				end
				data.collision = false
				data.cCount = 0
			else
				data.cCount = data.cCount + 1
			end
		end
	end
end
-------------------------------------------------------------------------------------
-- AI CODE
-------------------------------------------------------------------------------------
local function runAI(dt,vName,user,wp1,wp2,Arena)
	--print("called runAI "..vName)
	local data = derby_util.vehicleData[vName] --data table for the vehicle
	--if we don't have a target find one
	if data.targetSet ~= true then 
		data.target = findRandomTarget(vName)  --find a random target	
		if not data.target then data.target = user end
		data.targetObj = scenetree.findObject(data.target)
		data.targetSet = true
		--print(data.target)
	else
		 --Update Data		
		--map.objects returns objId, isactive, pos, vel, dirVec, dirVecUp, damage, objectCollisions
		vdata = map.objects[map.objectNames[vName]]
		if vdata == nil then return end
		tdata = map.objects[map.objectNames[data.target]]
		if tdata == nil then return end
		data.throttle = .6
		data.brake = 0.4
		local dirDiff, dirTarget = collisionCheck(dt,wp1,wp2,data,Arena)
		--Check the collision data to see if we hit our target
		local aiCollisions = vdata.objectCollisions
		local targetID = data.targetObj.obj:getID()  --get target id
		if aiCollisions ~= nil then
				--dump (aiCollisions)
			for k,v in pairs (aiCollisions) do
				if k == targetID then		
					data.hitTarget = true
				else
					data.hitTarget = false
				end
				data.lasthit = true
			end	
		end
		if dirTarget < -0.3 and data.lasthit == false then
			data.backup = true
		else
			if data.lasthit == false then
				data.backup = false
			end
		end
		if data.backup == true then
			counts(data,vName)
			--drive backwards and point steering wheel at the target -dirDiff
			derby_util.driveCar(vName,-dirDiff,0,data.brake,0) --brake 4
		else
			counts(data,vName)
			--drive forward and point steering wheel at the target -dirDiff
			derby_util.driveCar(vName,-dirDiff,data.throttle,0,0) --throttle 3
		end
	end
end

M.runAI = runAI


return M