-------------------------------------------------------------------------------------
-- Derby Lua Script
-- By Bidwars
-------------------------------------------------------------------------------------

local M = {}
local lastVehicleClass = {}  --Saves the last vehicle class so we don't have to reload the player vehicle each time.
local randomNumber = 0  
local custom = {} --The filtered list of vehicles 
local customList = {} -- The full list of vehicles 
local saveType = nil --The type of vehicle
local helper = require('scenario/scenariohelper')

math.randomseed(os.time())  --This is used for Random Math.
require('mathlib')
-------------------------------------------------------------------------------------
--CREATES A TABLE WITH CUSTOM CONFIGS.  EXAMPLE MODEL_KEY = DERBY2MOD AND KEY = FULLSIZE
-------------------------------------------------------------------------------------
local function writeCustom(i,cmodel_key,ckey)
	customList[i] = {
				model_key = cmodel_key,
				key = ckey
				}	
				i = i+1
	return i
end
-------------------------------------------------------------------------------------
--CREATES A LIST OF ALL THE VEHICLES IN BEAMNG
-------------------------------------------------------------------------------------
local function customClass(includeMods)	
	--get a table of all vehicles including mods 
	local configList = vehicles.getConfigList().configs
	--dump(configList)
	local i = 1
	for _,c in pairs(configList) do
		if includeMods == 5 then --All Mods and Beamng Offical
			if c.aggregates.Type.Car or c.aggregates.Type.Truck then
				i = writeCustom(i,c.model_key,c.key)
			end
		else
			if c.Source == "Mod" then
				local s = c.key
				if includeMods == 3 then  --F150 Mod
					if string.startswith( s, "derby" ) or string.startswith(s,"banger") or string.startswith(s,"duke") or string.startswith(s,"239a") then
						i = writeCustom(i,c.model_key,c.key)
					end
				elseif includeMods == 4 then --Peter Beamo Mod
					if string.startswith( s, "beamo" ) then
						i = writeCustom(i,c.model_key,c.key)
					end
				elseif includeMods == 2 and c.aggregates.Type.Car or c.aggregates.Type.Truck then  --All Mods
					i = writeCustom(i,c.model_key,c.key)
				end
			end	
		end
	end
end
local function random(classCount)
	-- random generating 
	if randomNumber == 0 then
		math.random(); math.random(); math.random()
		randomNumber = math.random(1,classCount)
	elseif classCount > 2 then
		local v = classCount
		v = v / 2
		print("classCount Divided")
		if randomNumber >= v then
			randomNumber = randomNumber + 1
			print("a")
		else
			randomNumber = randomNumber - 1
			print("b")
		end
	end
	if randomNumber > classCount or randomNumber < 1 then
		print("c")
		randomNumber = math.random(1,classCount)
	end
	print(randomNumber)
	return randomNumber
end

-------------------------------------------------------------------------------------
--GET ONE MODEL_KEY AND KEY 
-------------------------------------------------------------------------------------
local function modelName(vehicleClass,includeMods)
	local ran = nil
	local model_key = nil
	local key = nil
	local type = {
			["heavy"] = {semi = 4},
			["truck"] = {pickup = 4, roamer = 3, van = 3 },
			["large"] = {barstow = 4, burnside = 4, fullsize = 4, moonhawk = 4},
			["medium"] = {legran = 4, pessima = 4, midsize = 4, sunburst = 4,  etki = 4},
			["compact"] = {coupe = 4, hatch = 4, pessima = 4, sunburst = 4, miramar = 4},
			["luxury"] = {etkc = 4, etk800 = 4, super = 3, sbr = 2},	
			["randomv"] = {pickup = 4, roamer = 3, van = 3, barstow = 4, burnside = 4, fullsize = 4, moonhawk = 4, legran = 4, pessima = 4, midsize = 4, sunburst = 4, coupe = 4, hatch = 4, etki = 4, miramar = 4, etkc = 4, etk8001 = 4, super = 3, sbr = 2}
			}
	if includeMods > 1 then --Include Custom Mods
		if customList[1] == nil then
			customClass(includeMods)  --Creates the CustomList
			local count = 1
			for _,t in ipairs(customList) do
				if includeMods == 2 or includeMods == 5 and vehicleConfig == 7 then  --2 is all mods, 5 is all mods and Beamng, 7 is Random
					custom[count] = {key = t.key,model_key = t.model_key, types = "None"}
					count = count + 1
				else
					-- cycle the type table to see the values are equal to the customList table.  
					for typeName,typeTable in pairs(type) do --typename is heavy,truck,large,medium,compact,luxury, and randomv
						if typeName == "randomv" then
						else
							for typeValue,j in pairs(typeTable) do	
								if typeValue == t.model_key then
									--creates a List of vehicles with index,key,model_key,type   
									custom[count] = {key = t.key,model_key = t.model_key,types = typeName}
									count = count + 1
									break
								end
							end
						end
					end
				end
			end					
		end
		if not saveType or vehicleClass ~= 7 then  --saveType is saved so we don't have to cycle the type list again.
			if vehicleClass == 6 then
				saveType = "luxury"
			elseif vehicleClass == 5 then
				 saveType ="compact"
			elseif vehicleClass == 4 then
				saveType = "medium"
			elseif vehicleClass == 3 then
				saveType = "large"
			elseif vehicleClass == 2 then
				saveType = "truck"
			elseif vehicleClass == 1 then	
				saveType = "heavy"
			end
		end
		--
		local modelList = {}
		local count = 1
		for i,t in ipairs(custom) do
				if vehicleConfig == 7  then
					modelList[count] = {key = t.key,model_key = t.model_key}
					count = count + 1
				elseif t.types == saveType then
					modelList[count] = {key = t.key,model_key = t.model_key}
					count = count + 1
				end
		end
		if modelList[1] ~= nil then
			ran = math.random(#modelList)
			key = modelList[ran].key
			model_key = modelList[ran].model_key
			return model_key, key
		else
			helper.realTimeUiDisplay("No modded vehicles found for this class")
		end
	end
	if vehicleClass == 7 then --Random
		type = type.randomv
	elseif vehicleClass == 6 then -- Luxury Car
		type = type.luxury
	elseif vehicleClass == 5 then --Compact Car
		type = type.compact
	elseif vehicleClass == 4 then --Medium Car
		type = type.medium
	elseif vehicleClass == 3 then --Large Car
		type = type.large
	elseif vehicleClass == 2 then --Truck
		type = type.truck
	elseif vehicleClass == 1 then --Heavy
		type = type.heavy
	end
	if key ~= nil then
		return model_key, key
	else
		local List = {}
		local count = 1
		for modeln,qty in pairs(type) do
			for x=1, qty do
				List[count] = modeln..x
				count = count + 1
			end
		end
		ran = math.random(#List)
		model_key = List[ran]
		return model_key, key
	end
end
-------------------------------------------------------------------------------------
--CREATES A NEW PC FILE WITH PARTS WE NEED TO REMOVE SET TO NONE
-------------------------------------------------------------------------------------
local function deleteParts(data,JBeam, partName)
	for _,part in ipairs(partName) do
		local hubcap = string.sub(part, 1, 6)
		if hubcap == "hubcap" then
			data.parts[part] = "none"
		elseif data.parts[JBeam..''..part] then
			data.parts[JBeam..''..part] = "none"
		end
	end
end
local function readPartsFile(File)
	local parts = readJsonFile(File)
	if parts then
		return parts
	end
end
-------------------------------------------------------------------------------------
--CREATES THE VEHICLE CLASS PC FILE
-------------------------------------------------------------------------------------
local function loadClass(vehicleClass, includeMods, vehicleConfig, removePartsFile)
	local JBeam = nil
	local model_key, key = modelName(vehicleClass, includeMods)
	local partConfig = nil
	if key ~= nil then
		JBeam = model_key
			partConfig = string.format('vehicles/'..model_key..'/'..key..'.pc', model_key, key)  
			saveConfig = string.format('levels/derby/'..vehicleConfig..'_vehicles/'..model_key..'/v1'..key..'.pc', model_key, key)
	else
		local number = tonumber(string.match(model_key, "%d+"))
		JBeam = model_key:sub(1, -2)
		local setup
		if vehicleConfig > 3 then
			setup = "stock"
		else 
			setup = "derby"
		end
		partConfig = string.format('levels/derby/vehicles/'..JBeam..'/'..setup..'_'..model_key..'.pc')
		saveConfig = string.format('levels/derby/'..vehicleConfig..'_vehicles/'..JBeam..'/'..setup..'_v1'..model_key..'.pc')
	end
	if vehicleConfig == 5 then --stock
		return JBeam, partConfig
	else
		local partsData = readPartsFile(partConfig)
		if vehicleConfig == 4 then --Derby2 
			deleteParts(partsData,JBeam,removePartsFile.derby2)
			--local partName ={"_seats_R","_seat_FR","_mirror_R","_mirror_L","_innerfender_FR","_innerfender_FL","_glass","_exhaust_L","_exhaust_R","_doorpanel_L","_doorpanel_R","_exhaust","hubcap_F_16","hubcap_R_16","hubcap_R_15_alt","hubcap_F_15_alt","hubcap_R_15_altc","hubcap_F_15_altc","hubcap_F_15","hubcap_R_15","hubcap_F_14_alt","hubcap_R_14_alt","hubcap_F_14","hubcap_R_14","hubcap_F_13","hubcap_R_13","_antenna_trunk","_bumper_F_alt","_bumper_R_alt","_rallylights","_mudflap_R","_mudflap_L","_mudflap_FR","_mudflap_FL","_doorpanel_RL","_doorpanel_FL","_doorpanel_FR","_doorpanel_RR","_spoiler_window","_lip_F","_towhitch","_glass_wagon","_sparetire","_roofrack","_bedtoolbox_L","_bedtoolbox_R","_bedpipes","_glass_ext","_exhaust_v8","_muffler_ext","_bedextra","_muffler","_lightbar","_taillight_L","_taillight_R","_taillight","_lettering_v8","_lettering_hood","_grille","_headlight_R","_headlight_L","_lettering_DX","_rollcage","_lettering","_logo_F_grille","_fascia","_headlightcover_L","_headlightcover_R","_lettering_tailcone","_chrome","_spoiler","_logo_F","_logo_R","_logo_F_grille","_lettering_dxi","_lettering_trunk","_lettering_trunk_2400","_lettering_grille","_bumperlight_F","_bumperlight_R","_sideskirt","_trim_kit","_lights","_lipsignal","_foglight","_lettering_fender","_nosecone","_visor","_horn_R","_horn_L","_exhauststack_R","_exhauststack_L","_taillights_short","_hood_accessory","_tailcone","_tailcone_panel","_beaconlight","_roof_accessory","_trunk_accessory","_licenseplate_R","_licenseplate_F"} 
		end
		if vehicleConfig <= 3  then  --Derby
			deleteParts(partsData,JBeam,removePartsFile.derby)
			--local partName = {"_seats_R","_seat_FR","_mirror_R","_mirror_L","_innerfender_FR","_innerfender_FL","_glass","_bumper_F","_bumper_R","_exhaust_L","_exhaust_R","_doorpanel_L","_doorpanel_R","_exhaust","hubcap_F_16","hubcap_R_16","hubcap_R_15_alt","hubcap_F_15_alt","hubcap_R_15_altc","hubcap_F_15_altc","hubcap_F_15","hubcap_R_15","hubcap_F_14_alt","hubcap_R_14_alt","hubcap_F_14","hubcap_R_14","hubcap_F_13","hubcap_R_13","_antenna_trunk","_bumper_F_alt","_bumper_R_alt","_rallylights","_mudflap_R","_mudflap_L","_mudflap_FR","_mudflap_FL","_doorpanel_RL","_doorpanel_FL","_doorpanel_FR","_doorpanel_RR","_spoiler_window","_lip_F","_towhitch","_glass_wagon","_sparetire","_roofrack","_bedtoolbox_L","_bedtoolbox_R","_bedpipes","_glass_ext","_exhaust_v8","_muffler_ext","_bedextra","_muffler","_lightbar","_licenseplate_R","_licenseplate_F"} 
		end
		if vehicleConfig <= 2 then --Stripped
			deleteParts(partsData,JBeam,removePartsFile.stripped)
			--local partName = {"reardoor_R","_door_RL_wagon","_door_RR_wagon","_door_FR_wagon","reardoor_L","_door_RR","_door_FR","_door_RL","_door_R","_taillight_L","_taillight_R","_taillight","_lettering_v8","_lettering_hood","_grille","_headlight_R","_headlight_L","_bumperbar_F","_bumperbar_R","_lettering_DX","_rollcage","_lettering","_logo_F_grille","_fascia","_headlightcover_L","_headlightcover_R","_lettering_tailcone","_chrome","_spoiler","_logo_F","_logo_R","_logo_F_grille","_lettering_dxi","_lettering_trunk","_lettering_trunk_2400","_lettering_grille","_bumperlight_F","_bumperlight_R","_sideskirt","_trim_kit","_lights","_lipsignal","_foglight","_lettering_fender","_nosecone","_visor","_horn_R","_horn_L","_exhauststack_R","_exhauststack_L","_taillights_short","_hood_accessory","_tailcone","_tailcone_panel","_beaconlight","_roof_accessory","_trunk_accessory"} 
		end
		if vehicleConfig == 1 then --Low-End
			deleteParts(partsData,JBeam,removePartsFile.lowend)
			--local partName = {"_door_FL_wagon","_door_FL","_door_L","_seat_FL","_fender_R","_fender_L","_hood","_trunk","_tailgate","_gauges","_sidestep_L","_sidestep_R"}
		end
		serializeJsonToFile(saveConfig, partsData, true)
		--print("loaded "..vName.." config"..JBeam.." "..model_key.."")
		return JBeam, saveConfig
	end
end
-------------------------------------------------------------------------------------
--RESET THE CLASSES FILE ON RESTARTS
-------------------------------------------------------------------------------------
local function onScenarioRestarted()
	 lastVehicleClass = {}
	 randomNumber = 0
	 custom = {}
	 customList = {}
	 saveType = nil
end

M.readPartsFile = readPartsFile
M.loadClass = loadClass
M.onScenarioRestarted = onScenarioRestarted
return M