-------------------------------------------------------------------------------------
-- Derby Lua Script
-- By Bidwars
-------------------------------------------------------------------------------------

local M = {}
math.randomseed(os.time())  --This is used for Random Math.
local scenario = nil --Scenario Saved to this
--Helper for scenario lua commands
local helper = require('scenario/scenariohelper')
local raceMarker = require("scenario/race_marker")

local lastPosition = {} --Last position of the vehicle
local maxStopTicks = 700   --About 60 seconds --Max number of times the onPreRender(dt) loops before the vehicle is counted out
local Arena = 0  --Arena Selected
--AI Vehicles
local vehicleCountEntered = 0 --Number of AI vehicles
local vehicleConfig = 0  --Vehicle Config Selected equals the state
local vehicleClass = 0
local includeMods = 0 
local startvehicleConfig = 0
local startvehicleClass = 0  
local lapsEntered = 10
--Player Vehicle
local user = nil --User vehicle name
local player = {} --Player Object
--WayPoints
local wp1 = nil  
local wp2 = nil  
local place = {}
--Delay
local derbyTimer = 0 -- Used with delayStart to have a timer for when to resume
local delayStart = false  --Used Delay the Start of the senario until everything has loaded
local loadDone = false --Used to Start the senario when loading is done
local removePartsFile = {} --Table of parts to remove
M.scenarioVehicles = {}
M.vehiclesStopTicks = {} --The vehicle timeout counter up to the maxStopTicks
M.vTimeout = {} --Vehicles that have timed-out
M.vehIn = 0 --Number of vehicles still running
M.vehOut = 0 --Number of vehicles counted out
M.vehicleClass = 0 
require('mathlib')
-------------------------------------------------------------------------------------
--TORQUESCRIPT TO SET THE PARTS Config
-------------------------------------------------------------------------------------
local function TScript(vName,JBeam,pcs)
	TorqueScript.eval([[
			]]..vName..[[.JBeam = "]] .. JBeam .. [[";
			]]..vName..[[.partConfig = "]] .. pcs .. [[";
			]]..vName..[[.requestReload();
		]])
end
-------------------------------------------------------------------------------------
--SETS THE PARTS FOR EACH vehicle
-------------------------------------------------------------------------------------
local function partsConfig(firstLoad)
	local JBeamList = {}
	local rVehicles = scenetree.findClassObjects('BeamNGVehicle')
	local path = string.format('levels/derby/configs/removeParts.pc')
	removePartsFile = derby_classes.readPartsFile(path)
	local JBeam, pcs = derby_classes.loadClass(vehicleClass,includeMods,vehicleConfig,removePartsFile)
	--dump(pcs)
	for k, vName in pairs(rVehicles) do	
		local vObj = scenetree.findObject(vName)
		if vObj then
				if k == 1 then
					if startvehicleConfig == vehicleConfig and startvehicleClass == vehicleClass then	
						if firstLoad == true or includeMods > 1 then		
							TScript(vName,JBeam,pcs)
						end
					else
						TScript(vName,JBeam,pcs)
					end
					user = vName
					player = vObj
				end
		end
	end		
end

-------------------------------------------------------------------------------------
--MOVE THE VEHICLES TO THEIR STARTING POSITION
-------------------------------------------------------------------------------------
local function moveVehiclesPosition(vName, vehicleOffset, k)
		--Get the Waypoint x, y, and z positions 
		local pos = {}
		local offset = 30
		if Arena == 1 then
			offset = 50
		end
		if k > 8 then
			if Arena == 4 then  --Oval Track
				pos.x = wp1.x + wp2.x - 8
				pos.y = wp1.y + wp2.y 
			else
				pos.x = wp1.x + wp2.x 
				pos.y = wp1.y + wp2.y - offset
			end
		else
			pos.x = wp1.x + wp2.x
			pos.y = wp1.y + wp2.y 
		end
		pos.z = wp1.z	
		--Offsets the vehicles so they don't get moved over one another
		if Arena == 4 then
			pos.y = (pos.y + vehicleOffset) / 2
			pos.x = pos.x /2
		else
			pos.x = (pos.x + vehicleOffset) / 2
			pos.y = pos.y / 2
		end
		if Arena == 1 then
			print("moved y position")
			pos.y = pos.y + 15
		end
		print("x "..pos.x.. " y "..pos.y.. " z " .. pos.z)
		--Command to move the vehicles
		TorqueScript.eval('if(isObject('..vName..')){'..vName..'.position =" '..pos.x..' '..pos.y..' '..pos.z..' ";}')	
end
-------------------------------------------------------------------------------------
--CREATES THE AI VEHICLES FOR THE SCENARIO  
-------------------------------------------------------------------------------------
local function createVehicles()
		local driver = {"Basher","Tee","Little","John","Tim","Bo","Greg","Driver8","Driver9","Driver10","Driver11","Driver12","Driver13","Driver14","Driver15"}
		partsConfig(false)
	--color = "0.718231 0.36428 0.92572 1.426";
		for i=1,vehicleCountEntered do
			--JBeam is the vehicle type, and pcs is the parts Configuration
			local JBeam, pcs = derby_classes.loadClass(vehicleClass,includeMods,vehicleConfig,removePartsFile)
			local position = '177.222 120.331 79.2748'
			local vehicleTS = [[
			new BeamNGVehicle(]]..driver[i]..[[) {
			JBeam = "]]..JBeam..[[";
			partConfig = "]]..pcs..[[";
			renderDistance = "500";
			renderFade = "0.1";
			isAIControlled = "0";
			dataBlock = "default_vehicle";
			position = "]]..position..[[";
			rotation = "1 0 0 0";
			scale = "1 1 1";
			canSave = "1";
			canSaveDynamicFields = "1";
			};
			]]
			TorqueScript.eval(vehicleTS)
			be:reloadCollision()
		end
end
-------------------------------------------------------------------------------------
--LOAD vehicles
-------------------------------------------------------------------------------------
local function loadVehicles()
	local vehicleOffset = 0
	local offset = 8
	if Arena == 4 then  --Oval Track 
		offset = 12     --Arenas
	end
	local sVehicles = scenetree.findClassObjects('BeamNGVehicle')
	log('D', 'scenario', "found " .. #sVehicles .. " vehicles")
	--local userVehicle = math.random(1, #sVehicles)
	for k, vName in pairs(sVehicles) do	
		if k == 9 then
			vehicleOffset = 0
		end
		local vObj = scenetree.findObject(vName)
			if vObj then	
				M.scenarioVehicles[vName] = vObj
				--This sets the vehicle offset amount for moving vehicles to the starting spot
				if k == 1 then
				--Move the player 
				moveVehiclesPosition(vName, vehicleOffset, k)
				else
				--print("Checking Even Number Vehicle Offset value" ..vehicleOffset )
						if k % 2 == 0 then
						vehicleOffset = vehicleOffset + offset
						else 
							vehicleOffset = -1 * vehicleOffset
						end
						moveVehiclesPosition(vName, vehicleOffset, k)
						vehicleOffset = math.abs(vehicleOffset)
				end
				M.vehIn = M.vehIn + 1 	
			end
	end
end
-------------------------------------------------------------------------------------
--GET A LIST OF WAYPOINTS ON THE MAP
-------------------------------------------------------------------------------------
local function findWP()
local wpNum1 = 1
local wpNum2 = 2
	if Arena == 2 then
		wpNum1 = 3
		wpNum2 = 4
	elseif Arena == 1 then
		wpNum1 = 5
		wpNum2 = 6
	elseif Arena == 4 then
		wpNum1 = 7
		wpNum2 = 8
	end
	wp1 = scenetree.findObject('wp_' ..wpNum1):getPosition()
	wp2 = scenetree.findObject('wp_' ..wpNum2):getPosition()
end
local function createRoads()
	if Arena == 4 then
		scenario.lapCount = lapsEntered
		--local scenario = scenarios.getScenario()
		local objName = "dirttrackwp"
		local p = createObject('Prefab')
		p.filename = "levels/derby/waypoints/"..objName..".prefab"
		p.loadMode = 1 --'Manual'
		p.canSave  = true
		p.canSaveDynamicFields = true
		p:registerObject(objName)
		log('D', 'scenarios.spawnPrefab', 'loading prefab '..objName);
		p:load();
		scenetree.ScenarioObjectsGroup:addObject(p.obj)
        
		--update static collision with new prefabs
		be:reloadCollision()
	  -- we are figuring out the waypoints and build the node graph with the positions of the level
	 --  complete the node graph with the spawned waypoints
		local waypointsTable = scenetree.findClassObjects('BeamNGWaypoint')
			--log('D', 'scenario', "found " .. #waypointsTable .. " waypoints")
		scenario.nodes = {}
		local aiRadFac = (scenario.radiusMultiplierAI or 1)
		for k, nodeName in pairs(waypointsTable) do
			if string.startswith( nodeName, "dirttrack" ) then
				table.insert(scenario.lapConfig, nodeName)
				--log('D', 'scenario', tostring(k) .. ' = ' .. tostring(nodeName))
				local o = scenetree.findObject(nodeName)
				if o then
					if scenario.nodes[nodeName] == nil then
						local rota = nil
						if o:getField('directionalWaypoint',0) == '1' then
							rota = quat(o:getRotation())*vec3(1,0,0)
						end
						scenario.nodes[nodeName] = {
						pos = vec3(o:getPosition()),
						radius = o:getScale():len() * aiRadFac,
						rot = rota
						}
					end
				else
					--log('E', 'scenario', 'waypoint not found: ' .. tostring(nodeName))
				end
			end
		 end	
		derby_race.getRoads()
	else
		scenario.lapCount = 1
	end

end
-------------------------------------------------------------------------------------
--GET THE NUMBER OF AI VEHICLES, ARENA SELECTED, AND STATE FROM THE demo_derby.js FILE
-------------------------------------------------------------------------------------
local function Selection(enteredCount,class,mods,state,arena)
	print("Vehicle Count "..enteredCount)
	print("Class "..class)
	print("Mods "..mods)
	print("State "..state)
	print("Arena "..arena)
	vehicleCountEntered = tonumber(enteredCount)
	vehicleClass = tonumber(class)
	M.vehicleClass = vehicleClass
	includeMods = tonumber(mods)
	vehicleConfig = tonumber(state)	
	Arena = tonumber(arena)	
end
local function lapSelection(enteredLaps)
	--print("laps "..enteredLaps)
	lapsEntered = tonumber(enteredLaps)
end
-------------------------------------------------------------------------------------
--SCENARIO START
-------------------------------------------------------------------------------------
local function onScenarioChange(sc)
	scenario = sc
	if not scenario then return end
	if scenario.state == 'pre-start' and delayStart == false then
		--Set the default partsconfig
		Selection(4,3,1,3,3)
		partsConfig(true)
		startvehicleConfig = vehicleConfig
		startvehicleClass = vehicleClass
	end
	if scenario.state == 'running' and delayStart == false then			
		createVehicles()
		createRoads()
		findWP()
		loadVehicles()
		--delay the start of the senario so everything has a chance to load
		delayStart = true
		scenario.state = 'pre-running' --set the senario back to pre-running.  
		extensions.hook('onScenarioChange', scenario)
	end
end
-------------------------------------------------------------------------------------
--FUNCTION TO FREEZE AND UNFREEZE VEHICLES BEFORE THE START
-------------------------------------------------------------------------------------
local function freezeAll(state)
	for vName, vObj in pairs(M.scenarioVehicles) do
        vObj:queueLuaCommand('scenario.freeze('..tostring(state) ..')')
		if state == 1 then
			lastPosition[vName] = vObj:getPosition()
			derby_util.setupVehicles(vName,user)
			derby_util.vehicleData[vName].startPos = vec3(lastPosition[vName])
		end
    end
 end

 ------------------------------------------------------------------------------------
 --WHEN THE SENARIO COUNTDOWN TIMER REACHES GO!
 ------------------------------------------------------------------------------------
local function onScenarioRaceCountingDone()
	loadDone = true
	freezeAll(0)
	guihooks.trigger('ShowApps', true)
end
local function fail(result)
	scenarios.finish({failed = result})
end
local function success(result)
	scenarios.finish(result)
end
local vehCount = 0 
local racePlace = {}
local function updatePlace()
	if Arena == 4 then
		local numVehicles = vehicleCountEntered + 1
		vehCount = vehCount + 1
		if numVehicles == vehCount then
		for vName,_ in pairs(M.scenarioVehicles) do
			local vd = derby_util.vehicleData[vName]
			
			local count = 1
			--print(vName)
			--print("lcount "..vd.lCount.." ccount"..vd.cCount.." Dist"..vd.sDist.." end")
			for name, d in pairs(derby_util.vehicleData) do
				if name ~= vName then
					if vd.lCount < d.lCount then
					count = count + 1
					--print("lcount + 1")
					else 
						if vd.lCount <= d.lCount then
							if vd.cCount < d.cCount then
							count = count + 1
							--print("ccount + 1") 
							else
								if vd.cCount <= d.cCount then
									if vd.sDist > d.sDist then
										count = count + 1
										--print("sdist + 1") 
									end		
								end	
							end
						end
					end
				end	
			end
			--print(count)
			place[count] = vName	
		end
		if racePlace[1] ~= place[1] or racePlace[2] ~= place[2] or racePlace[3] ~= place[3] then
			racePlace[1] = place[1]
			racePlace[2] = place[2]
			racePlace[3] = place[3]
			guihooks.trigger('DerbyPlaceChange', { one = place[1], two = place[2], three = place[3]} )
			--dump(place
		end 
		place = {}	
		vehCount = 0	
		end
	end
end
-------------------------------------------------------------------------------------------
--MAIN SCENARIO TIMER LOOP 
-------------------------------------------------------------------------------------------
local function onPreRender(dt)
	if delayStart == true then
		helper.realTimeUiDisplay("LOADING VEHICLES")
		if derbyTimer == 4 then
			freezeAll(1)
			be:enterVehicle(0, player.obj)
			commands.setCameraPlayer()
			scenario.focusSlot = player.obj:getID()
		end
		if derbyTimer == 25 then
			scenarios.onScenarioUIReady('play')
			derbyTimer = 0
			delayStart = false
		else
		derbyTimer = derbyTimer + 1
		end
	end
	if loadDone == false then return end
	--print("Running Timer")
	--vObj is the Vehicle Object and vName is the Name of the vehicle.
	for vName, vObj in pairs(M.scenarioVehicles) do
		vObj:queueLuaCommand('energyStorage.getStorage("mainTank"):setRemainingVolume(1)')
		vObj:queueLuaCommand('fire.extinguishVehicle()')
		--print(vName)
		if M.vTimeout[vName] == nil or M.vTimeout[vName] ~= vName then 
			if M.vehOut >= 1 and M.vehIn == 1 then
				--Senario is finished display win message
				if M.vTimeout[user] == nil then
					local result = {msg = 'You Won!'}
					success(result)
				else
					fail('The driver '..vName..' has won.')
				end
				loadDone = false	
				break
			end
			local position = vObj:getPosition()
			local v3position = vec3(position)
			if Arena == 4 then
				local aiRadFac = (scenario.radiusMultiplierAI or 1)
				local cPoint = derby_util.vehicleData[vName].cCount
				local lap = derby_util.vehicleData[vName].lCount 
				if cPoint == 0 then
					cPoint = 1
				else
					derby_util.vehicleData[vName].dtCount = 1
				end
				if lap == 0 then
					lap = 1
				end
				for wp,node in pairs(scenario.nodes) do
					local bestwp = string.match(wp, '%d+')
					--print(bestwp)
					
					bestwp = tonumber(bestwp)
					if bestwp == cPoint then
						local wpdist = node.pos:distance(v3position)
						if wpdist < aiRadFac then
							if derby_util.vehicleData[vName].dtCount == 1 then
								cPoint = cPoint + 1
								if cPoint == 6 then
									cPoint = 1 
									lap = lap + 1
								end
								local w = "dirttrackwp_"..cPoint
								wpdist = scenario.nodes[w].pos:distance(v3position)
							end
						
						end
						derby_util.vehicleData[vName].cCount = cPoint
						derby_util.vehicleData[vName].sDist = wpdist
						derby_util.vehicleData[vName].lCount = lap
						break
					end
				end	
				updatePlace(vName)
			end
			if vName ~= user then --~=  Should be
				--Get the ai moving 
				if Arena == 4 then	
					derby_race.run_AIrace(vName,position,user)
				else
					derby_ai.runAI(dt,vName,user,wp1,wp2,Arena)
				end
			else
				raceMarker.hide(true)
			end
				--Get the distance from the last position
				--print(position)
			if position.z < wp1.z - 2 then
					M.vehiclesStopTicks[vName] = maxStopTicks
			end
			local distance =  math.abs((position - lastPosition[vName]):len())
			if distance > 0.4 then
				--vehicles still moving
				lastPosition[vName] = position
				M.vehiclesStopTicks[vName] = 0			
			else
				--Add one stop tick to the vehicles stop ticks
						M.vehiclesStopTicks[vName] = M.vehiclesStopTicks[vName] + 1 
				--If they reach the max stop ticks then they are out
				
				if M.vehiclesStopTicks[vName] > maxStopTicks  then	
					M.vehOut = M.vehOut + 1	
					M.vehIn = M.vehIn - 1
					M.vTimeout[vName] = vName
					local msg = vName .. ' has been called out!'
					helper.flashUiMessage(msg, 3)
					vObj:queueLuaCommand('scenario.freeze('..tostring(1) ..')')
				end
			end	
		end
	end
end
-------------------------------------------------------------------------------------
--DELETE VEHICLES 
-------------------------------------------------------------------------------------
local function deleteVehicles(obj)
		TorqueScript.eval('setCameraFree();')
		if obj then
			obj:delete()
			--Update static collision with new prefabs
			be:reloadCollision()
		end
end
-------------------------------------------------------------------------------------
--TRIGGERED ANYTIME THE SENARIO IS RESTARTED
-------------------------------------------------------------------------------------
local function onScenarioRestarted()
	local rVehicles = scenetree.findClassObjects('BeamNGVehicle')
	for k, vName in pairs(rVehicles) do	
		local vObj = scenetree.findObject(vName)
		if vObj then
			if k ~= 1 then
				log('D', 'scenario', "Deleting Vehicle "..vName)
				deleteVehicles(vObj)
			end
		end
	end
	local objName = "dirttrackwp"
	local obj = scenetree[objName]
	if obj then
		log('D', 'scenarios.spawnPrefab', 'unloading Prefab '..objName)
		obj:unload()
		obj:delete()
	
		be:reloadCollision()
	end
end

M.Selection = Selection
M.lapSelection = lapSelection
M.onRaceTick = onRaceTick
M.onScenarioChange = onScenarioChange
M.onScenarioRaceCountingDone = onScenarioRaceCountingDone
M.onPreRender = onPreRender
M.onScenarioRestarted = onScenarioRestarted

return M